/*
 * File: app/controller/viewController.js
 *
 * This file was generated by Sencha Architect version 3.0.2.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.controller.viewController', {
	extend: 'Ext.app.Controller',

	models: [
		'SNMPCommunity'
	],
	stores: [
		'SNMPCommunityDB'
	],
	views: [
		'Main'
	],

	refs: [
		{
			ref: 'autoDiscoveryCheckBox',
			selector: '#autoDiscovery'
		},
		{
			ref: 'tabSnmp',
			selector: 'panel#tabSnmp'
		},
		{
			ref: 'formSnmp',
			selector: 'panel#formSnmp'
		},
		{
			ref: 'elementsDiscovered',
			selector: '#elementsDiscovered'
		},
		{
			ref: 'autoImportCheckBox',
			selector: '#fastAdd'
		},
		{
			ref: 'discoveredElementsGrid',
			selector: '#discoveredElementsGrid'
		},
		{
			ref: 'sendIpBox',
			selector: '#sendIp'
		},
		{
			ref: 'disksDetails',
			selector: '#disksDetails'
		},
		{
			ref: 'processesDetails',
			selector: '#processesDetails'
		},
		{
			ref: 'portDetails',
			selector: '#portDetails'
		},
		{
			ref: 'servicesDetails',
			selector: '#servicesDetails'
		},
		{
			ref: 'detailsPanel',
			selector: '#detailsPanel'
		},
		{
			ref: 'password',
			selector: '#password'
		},
		{
			ref: 'passwordConfirmation',
			selector: '#passwordConfirmation'
		},
		{
			ref: 'email',
			selector: '#email'
		},
		{
			ref: 'emailConfirmation',
			selector: '#emailConfirmation'
		},
		{
			ref: 'mainView',
			selector: '#mainView'
		},
		{
			ref: 'interfacesDetails',
			selector: '#interfacesDetails'
		}
	],

	onButtonClick: function(button, e, eOpts) {

		if (button.id == "addSnmp") {

			var record = Ext.create("Discovery.model.SNMPCommunity");
			var formSnmp = this.getFormSnmp().getForm();
			formSnmp.loadRecord(record);

			var tabSnmp = this.getTabSnmp();
			tabSnmp.layout.setActiveItem('formSnmp');
			return;

		}

		if (button.id == "formSnmpSave") {

			var snmpStore = this.getSNMPCommunityDBStore();
			var formSnmp = this.getFormSnmp();
			formSnmp.getForm().updateRecord();
			var record = formSnmp.getForm().getRecord();

			if (record.data.community_id === 0) {
				snmpStore.add(record);
				snmpStore.sync();

			} else {

				var comm = snmpStore.getById(record.data.community_id);
				comm = record;
				snmpStore.sync();
			}

			var tabSnmp = this.getTabSnmp();
			tabSnmp.layout.setActiveItem('listSnmp');

			return;

		}

		if (button.id == "formSnmpCancel") {

			var tabSnmp = this.getTabSnmp();
			tabSnmp.layout.setActiveItem('listSnmp');
			return;

		}
	},

	init: function(application) {
				var updateDiscoveryJobsTask = {
					run: function() {
						Discovery.getApplication().getDiscoveryJobDBStore().reload();
					},
					interval: 10000
				};

				var updateDiscoveredElements = {
					run: function() {
						Discovery.getApplication().getHostDiscoveryDBStore().reload();
					},
					interval: 50000
				};


				Ext.TaskManager.start(updateDiscoveryJobsTask);
				Ext.TaskManager.start(updateDiscoveredElements);


				var url = null;
				url = document.URL;

				Discovery.wizard = (url.indexOf("wizard") != -1);
				Discovery.topology = (url.indexOf("topology") != -1);

		this.control({
			"button": {
				click: this.onButtonClick
			}
		});
	},

	applyFilter: function() {
		store = Discovery.getApplication().getHostDiscoveryDBStore();
		if (Discovery.filterValue == undefined ||
		    Discovery.filterValue == null ||
		    Discovery.filterValue == "") {

			store.clearFilter(false);
			return;
		}

		store.clearFilter(true);
		store.filter("data_to_filter", Discovery.filterValue);
	}

});
