/*
 * File: app/view/MyPanel28.js
 *
 * This file was generated by Sencha Architect version 3.0.2.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.view.MyPanel28', {
	extend: 'Ext.panel.Panel',

	requires: [
		'Ext.form.Panel',
		'Ext.view.View',
		'Ext.XTemplate',
		'Ext.button.Button',
		'Ext.panel.Tool',
		'Ext.form.FieldSet',
		'Ext.form.field.ComboBox',
		'Ext.form.field.Checkbox'
	],

	width: 305,
	title: 'My Panel',

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'panel',
					id: 'tabElements1',
					width: 150,
					bodyPadding: 4,
					collapseDirection: 'left',
					collapsible: false,
					title: 'Descobrir IPs e Ranges',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'form',
							id: 'sendIpPanel1',
							layout: 'column',
							bodyPadding: '10 15',
							header: false,
							title: 'My Form',
							items: [
								{
									xtype: 'triggerfield',
									validator: function(value) {
										var i;
										var j;
										var aux;
										var is_valid = false;
										var entered_mask = "";
										var mask_pieces = [];
										var piece = "";
										var add_ip_button;
										var valid_ips_regexes = new Array(
										/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d\d?\d?$/,
										/^\d{1,3}\.\d{1,3}\.\d{1,3}\.[1-9{1,3}\*]$/,
										/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}-\d{1,3}\.\d{1,3}\.\d{1,3}\.[0-9]{1,3}$/
										);

										add_ip_button = Ext.fly('addIp');

										if (value == "") {
											add_ip_button.addCls('button-disabled');
											return false;
										}
										add_ip_button.removeCls('button-disabled');


										for(i=0; i<valid_ips_regexes.length; i++) {

											if (value.match(valid_ips_regexes[i]) ) {

												entered_mask = value;
												mask_pieces = entered_mask.split(/[\.-]/);

												if (mask_pieces.length != 4 && mask_pieces.length != 8)
												break;

												if (mask_pieces.length == 4) {

													if (mask_pieces[0] < 255 && mask_pieces[1] && mask_pieces[2]) {
														if (mask_pieces[3] == "*" || mask_pieces[3] < 255) {
															is_valid = true;
														}
													}

												} else {

													aux = 0;
													for(j=0; j<mask_pieces.length; j++) {
														if (mask_pieces[j] > 254) {
															aux = 1;
															break;
														}
													}

													if (aux == 0)
													is_valid = true;
												}

											}

										}

										if (is_valid) {
											add_ip_button.removeCls('button-error');
										} else {
											add_ip_button.addCls('button-error');
										}

										return is_valid
									},
									onTriggerClick: function() {

										var sendIp = Discovery.getApplication().getViewControllerController().getSendIpBox();

										if (!sendIp.isValid())
										return;

										Ext.Ajax.request({
											method: "POST",
											url: "/opmon/seagull/www/index.php/discovery/action/discovery_jobs/",
											params: {
												operation: "add",
												mask: sendIp.getValue()
											},
											success: function(result, request) {

												var ret;
												var store;

												ret = JSON.parse(result.responseText);
												if (!ret) {
													Ext.MessageBox.show({
														title: "Erro",
														msg: result.responseText,
														icon: Ext.MessageBox.ERROR
													});
													return;
												}

												if (!ret.success) {
													Ext.MessageBox.show({
														title: "Erro",
														msg: ret.message,
														icon: Ext.MessageBox.ERROR
													});
													return;
												}

												sendIp.reset();
												Ext.MessageBox.show({
													title: "Novo IP ou Range",
													msg: "Novo IP ou range adicionado.",
													icon: Ext.MessageBox.INFO,
													closable: false
												});
												setTimeout(function(){Ext.MessageBox.hide();},1000);
											},
											failure: function(result, request) {
												Ext.MessageBox.show({
													title: "Não foi possível acessar o servidor",
													msg: "Novo IP/Range não adicionado.",
													icon: Ext.MessageBox.ERROR,
													closable: false
												});
												setTimeout(function(){Ext.MessageBox.hide();},1000);
											}
										});
									},
									border: '1 0 1 1',
									id: 'sendIp1',
									width: 257,
									fieldLabel: 'Adicionar Range ou IP à descoberta',
									hideLabel: true,
									labelAlign: 'top',
									labelSeparator: ' ',
									inputId: 'inputIp',
									emptyText: 'Adicionar Range ou IP à descoberta',
									validateBlank: true,
									triggerCls: 'advance-trigger',
									listeners: {
										keypress: {
											fn: me.onSendIpKeypress1,
											scope: me
										}
									}
								}
							]
						},
						{
							xtype: 'container',
							margins: '-10 0 0',
							height: 30,
							html: '<h5 class=\'section-sub2\'>Ips e Ranges a serem processados</h5>',
							id: 'listTitle1',
							padding: '10 13 0'
						},
						{
							xtype: 'dataview',
							flex: 1,
							frame: false,
							id: 'listIPelements1',
							padding: 15,
							emptyText: 'Não há IPs ou ranges a serem processados',
							itemSelector: 'div',
							itemTpl: [
								'<span class=\'ip-item\'><span class=\'ip-item-left\'>{mask} </span></span>'
							],
							loadingCls: 'loading-ip',
							store: 'DiscoveryJobDB',
							listeners: {
								select: {
									fn: me.onListIPelementsSelect1,
									scope: me
								}
							}
						}
					]
				},
				{
					xtype: 'panel',
					id: 'tabSnmp1',
					width: 150,
					layout: 'card',
					bodyPadding: 4,
					collapseDirection: 'left',
					collapsed: false,
					collapsible: false,
					title: 'Comunidades SNMP',
					items: [
						{
							xtype: 'panel',
							cls: 'tab-sub-header',
							id: 'listSnmp1',
							header: false,
							title: 'Lista de Comunidades',
							items: [
								{
									xtype: 'button',
									id: 'addSnmp1',
									itemId: 'nextBtn',
									margin: 15,
									text: 'Adicionar comunidade SNMP'
								},
								{
									xtype: 'container',
									height: 30,
									html: '<h5 class=\'section-sub2\'>Comunidades Adicionadas</h5>',
									id: 'listTitleCom1',
									margin: '-10 0 0',
									padding: '10 13 0'
								},
								{
									xtype: 'dataview',
									frame: false,
									id: 'list-snmp-elements1',
									padding: 15,
									emptyText: 'Não há comunidade SNMP adicionada',
									itemSelector: 'div',
									itemTpl: [
										'<span class=\'snmp-item\'><span class=\'snmp-item-left\'>{community} </span><span class=\'snmp-item-right\'>v{snmp_version}</span></span>'
									],
									store: 'SNMPCommunityDB',
									listeners: {
										select: {
											fn: me.processSelect1,
											scope: me
										}
									}
								}
							],
							tools: [
								{
									xtype: 'tool',
									id: 'helpListSnmp1',
									tooltip: 'Ajuda',
									type: 'help'
								}
							]
						},
						{
							xtype: 'form',
							cls: 'tab-sub-header',
							id: 'formSnmp1',
							itemId: 'formSnmp',
							autoScroll: true,
							title: 'Definir os parâmetros da Comunidade',
							titleCollapse: false,
							layout: {
								type: 'vbox',
								align: 'stretch',
								padding: '15 15 40 15'
							},
							items: [
								{
									xtype: 'fieldset',
									id: 'formSnmpVersion1',
									title: 'Versão',
									items: [
										{
											xtype: 'combobox',
											anchor: '100%',
											id: 'formSnmpVersionSelect1',
											fieldLabel: 'SNMP',
											name: 'snmp_version',
											store: [
												[
													'1',
													'v1'
												],
												[
													'2c',
													'v2c'
												],
												[
													'3',
													'v3'
												]
											]
										}
									]
								},
								{
									xtype: 'fieldset',
									id: 'formSnmpAuth1',
									width: 338,
									title: 'Autenticação',
									items: [
										{
											xtype: 'textfield',
											anchor: '100%',
											id: 'formSnmpAuthCommunity1',
											fieldLabel: 'Comunidade',
											name: 'community'
										},
										{
											xtype: 'combobox',
											anchor: '100%',
											id: 'formSnmpAuthProtocol1',
											fieldLabel: 'Protocolo',
											name: 'authentication_protocol',
											store: [
												'SHA',
												'MD5'
											]
										},
										{
											xtype: 'textfield',
											anchor: '100%',
											id: 'formSnmpAuthPass1',
											fieldLabel: 'Senha',
											name: 'authentication_passphrase'
										}
									]
								},
								{
									xtype: 'fieldset',
									id: 'formSnmpSecurity1',
									width: 150,
									title: 'Segurança',
									items: [
										{
											xtype: 'combobox',
											anchor: '100%',
											id: 'formSnmpSecurityLevel1',
											fieldLabel: 'Level',
											name: 'security_level',
											store: [
												'authPriv',
												'authNoPriv',
												'noAuthNoPriv'
											]
										},
										{
											xtype: 'textfield',
											anchor: '100%',
											id: 'formSnmpSecurityContext1',
											fieldLabel: 'Contexto',
											name: 'context_name'
										},
										{
											xtype: 'textfield',
											anchor: '100%',
											id: 'formSnmpSecurityUser1',
											fieldLabel: 'Usuário',
											name: 'security_username'
										}
									]
								},
								{
									xtype: 'fieldset',
									height: 107,
									id: 'formSnmpPrivacy1',
									title: 'Privacidade',
									items: [
										{
											xtype: 'combobox',
											anchor: '100%',
											id: 'formSnmpPrivacyProtocol1',
											fieldLabel: 'Protocolo',
											name: 'privacy_protocol',
											store: [
												'AES',
												'DES'
											]
										},
										{
											xtype: 'textfield',
											anchor: '100%',
											id: 'formSnmpPrivacyPass1',
											fieldLabel: 'Senha',
											name: 'privacy_protocol_passphrase'
										},
										{
											xtype: 'textfield',
											anchor: '100%',
											id: 'formSnmpPrivacyDestiny1',
											fieldLabel: 'Destino',
											name: 'destination_engine'
										}
									]
								},
								{
									xtype: 'container',
									flex: 1,
									id: 'formSnmpButtons1',
									layout: 'column',
									items: [
										{
											xtype: 'container',
											columnWidth: 0.7,
											id: 'formSnmpCancelContainer1',
											items: [
												{
													xtype: 'button',
													cls: 'button-weak',
													height: 30,
													id: 'formSnmpCancel1',
													text: 'Cancelar',
													listeners: {
														click: {
															fn: me.onFormSnmpCancelClick1,
															scope: me
														}
													}
												}
											]
										},
										{
											xtype: 'button',
											columnWidth: 0.3,
											height: 30,
											id: 'formSnmpSave1',
											text: 'Salvar',
											listeners: {
												click: {
													fn: me.onFormSnmpSaveClick1,
													scope: me
												}
											}
										}
									]
								}
							],
							tools: [
								{
									xtype: 'tool',
									id: 'helpFormSnmp1',
									tooltip: 'Ajuda',
									type: 'help'
								}
							]
						}
					]
				}
			],
			dockedItems: [
				{
					xtype: 'container',
					dock: 'bottom',
					id: 'tabOptions1',
					padding: '15 15 4',
					width: 150,
					items: [
						{
							xtype: 'checkboxfield',
							id: 'autoDiscovery1',
							boxLabel: 'Descoberta Automática Ativa',
							listeners: {
								added: {
									fn: me.onAutoDiscoveryAdded1,
									scope: me
								},
								change: {
									fn: me.onAutoDiscoveryChange1,
									scope: me
								}
							}
						},
						{
							xtype: 'checkboxfield',
							hidden: true,
							id: 'fastAdd1',
							boxLabel: 'Adição rápida de elementos',
							listeners: {
								change: {
									fn: me.onFastAddChange1,
									scope: me
								},
								added: {
									fn: me.onFastAddAdded1,
									scope: me
								}
							}
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onSendIpKeypress1: function(textfield, e, eOpts) {

	},

	onListIPelementsSelect1: function(dataviewmodel, record, eOpts) {
		var e;
		var i;

		if (Discovery.ipContextMenu !== undefined) {
			Discovery.ipContextMenu.destroy();
		}

		Discovery.ipContextMenu = Ext.create('Discovery.view.SnmpMenu', {
			cancelJob: record,
			items: [
			{
				text: 'Cancel',
				listeners: {
					click:  function(button) {

						var job;

						job = Discovery.ipContextMenu.cancelJob;

						Ext.Ajax.request({
							method: "POST",
							params: {
								operation: "cancel",
								job_id: job.data.id
							},
							url: "/opmon/seagull/www/index.php/discovery/action/discovery_jobs/",
							success: function(result, request) {

								var ret = JSON.parse(result.responseText);
								if (!ret.success) {
									Ext.MessageBox.show({
										title: "Error",
										msg: ret.message,
										icon: Ext.MessageBox.ERROR
									});
									return;
								}

								Ext.MessageBox.show({
									title: "Confirmation",
									msg: "Job canceled sucessfully.",
									icon: Ext.MessageBox.INFO,
									closable: false
								});
								setTimeout(function(){Ext.MessageBox.hide();},2000);

							}

						});

					}
				}
			}
			]
		});

		for (i=0; i<dataviewmodel.view.all.elements.length; i++) {
			e = dataviewmodel.view.all.elements[i];
			if (e.attributes['class'].nodeValue.indexOf("selected") != -1) {
				Discovery.ipContextMenu.show();
				Discovery.ipContextMenu.anchorTo(e);
				return;
			}
		}
	},

	processSelect1: function(dataviewmodel, record, eOpts) {
		var e;
		var i;

		Discovery.getApplication().getViewControllerController().communityBeingEditted = record;
		if (Discovery.commContextMenu !== undefined) {
			Discovery.commContextMenu.destroy();
		}

		Discovery.commContextMenu = Ext.create('Discovery.view.SnmpMenu', {
			items: [
			{
				text: 'Editar',
				listeners: {
					click:  function(button) {

						var controller = Discovery.getApplication().getViewControllerController();
						var comm = controller.communityBeingEditted;
						var form = controller.getFormSnmp();
						var tabSnmp = controller.getTabSnmp();
						var simpleForm = form.getForm();

						tabSnmp.layout.setActiveItem('formSnmp');
						simpleForm.loadRecord(comm);
					}
				}
			},
			{
				text: 'Remover',
				listeners: {
					click: function(button) {

						var controller = Discovery.getApplication().getViewControllerController();
						var comm = controller.communityBeingEditted;
						var store = controller.getSNMPCommunityDBStore();
						var comm_index = store.find("community_id",comm.data.community_id);
						store.removeAt(comm_index);
						store.sync();

					}
				}
			}
			]
		});


		for (i=0; i<dataviewmodel.view.all.elements.length; i++) {
			e = dataviewmodel.view.all.elements[i];
			if (e.attributes['class'].nodeValue.indexOf("selected") != -1) {
				Discovery.commContextMenu.show();
				Discovery.commContextMenu.anchorTo(e);
				return;
			}
		}
	},

	onFormSnmpCancelClick1: function(button, e, eOpts) {
		//this.items.map.content.items.map.leftContent.items.map.tabSnmp.layout.setActiveItem('listSnmp');
	},

	onFormSnmpSaveClick1: function(button, e, eOpts) {
		//Ext.MessageBox.alert('Nova comunidade','Registro efetuado com sucesso');
		//this.items.map.content.items.map.leftContent.items.map.tabSnmp.layout.setActiveItem('listSnmp');
	},

	onAutoDiscoveryAdded1: function(component, container, pos, eOpts) {

		Ext.Ajax.request({
			method: "GET",
			url: "/opmon/seagull/www/index.php/discovery/action/auto_discovery/",
			success: function(result, request) {

				var ret = JSON.parse(result.responseText);
				if (!ret.success) {
					console.log(result.responseText);
					return;
				}

				var status = (ret.auto_discovery_status === "1") ? true : false;
				var discovery = Discovery.getApplication().getViewControllerController();
				var cb = discovery.getAutoDiscoveryCheckBox();
				cb.setValue(status);

			}

		});
	},

	onAutoDiscoveryChange1: function(field, newValue, oldValue, eOpts) {

		Ext.Ajax.request({
			method: "POST",
			url: "/opmon/seagull/www/index.php/discovery/action/auto_discovery/",
			params: {
				operation: "set",
				status: (newValue) ? "1" : "0"
			},
			success: function(result, request) {

				var ret = JSON.parse(result.responseText);
				if (!ret.success) {
					console.log(result.responseText);
					return;
				}

				var status = (ret.auto_discovery_status === "1") ? true : false;
				var discovery = Discovery.getApplication().getViewControllerController();
				var cb = discovery.getAutoDiscoveryCheckBox();
				cb.setValue(status);

			}

		});
	},

	onFastAddChange1: function(field, newValue, oldValue, eOpts) {
		Ext.Ajax.request({
			method: "POST",
			url: "/opmon/seagull/www/index.php/discovery/action/auto_import/",
			params: {
				operation: "set",
				status: (newValue) ? "1" : "0"
			},
			success: function(result, request) {

				var ret = JSON.parse(result.responseText);
				if (!ret.success) {
					console.log(result.responseText);
					return;
				}

				var status = (ret.auto_import_status === "1") ? true : false;
				var discovery = Discovery.getApplication().getViewControllerController();
				var cb = discovery.getAutoImportCheckBox();
				cb.setValue(status);

			}

		});
	},

	onFastAddAdded1: function(component, container, pos, eOpts) {
		Ext.Ajax.request({
			method: "GET",
			url: "/opmon/seagull/www/index.php/discovery/action/auto_import/",
			success: function(result, request) {

				var ret = JSON.parse(result.responseText);
				if (!ret.success) {
					console.log(result.responseText);
					return;
				}

				var status = (ret.auto_import_status === "1") ? true : false;
				var discovery = Discovery.getApplication().getViewControllerController();
				var cb = discovery.getAutoImportCheckBox();
				cb.setValue(status);

			}

		});
	}

});