/*
 * File: app/controller/EditHostsController.js
 *
 * This file was generated by Sencha Architect version 3.0.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.controller.EditHostsController', {
	extend: 'Ext.app.Controller',

	models: [
		'Contact',
		'TimePeriod',
		'Host',
		'HostGroup'
	],
	stores: [
		'contactStore',
		'hostGroupStore',
		'hostStore',
		'timePeriodStore',
		'serviceGroupStore',
		'hostDiscoveryStore'
	],

	refs: [
		{
			ref: 'serviceGrid',
			selector: '#sgrid'
		}
	],

	init: function(application) {
		var url;


		if (parent.WIZZARD_CONFIG_PARAMS === undefined ||
			parent.WIZZARD_CONFIG_PARAMS === null) {

			showError(l["Error"],l["Invalid request"]);
			return;
		}

		Wizard.urlData = parent.WIZZARD_CONFIG_PARAMS;
	},

	addHost: function(hostname) {

		if (!this.hostNames) {
			this.hostNames = new Array();
		}

		this.hostNames.push(hostname);
	},

	addHostBuckets: function(buckets, doNotCreateUniq) {
		var hostStore;
		var i;
		var serviceKnown = {};
		var j;
		var service;
		var host;
		var pos;
		var aux;

		this.hostBuckets = buckets;

		hostStore = this.application.getHostStoreStore();
		hostStore.removeAll();
		hostStore.add(buckets);

		if (doNotCreateUniq === undefined)
		createServicesUniqList();
	},

	getEditableServices: function() {
		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/discovery/action/servicebuckets/',
			method: 'POST',
			params: {
				services_being_edited: JSON.stringify(Wizard.urlData.services)
			},
			success: function(result, request) {

				var obj;
				var i;

				obj = JSON.parse(result.responseText);
				if (!obj) {
					showError(l["Unexpected error"], l["JSON not found"]);
					return;
				}

				if (!obj.success) {
					showError(l["Error"], obj.message);
					return;
				}

				if (obj.message)
					showError(l["Warning"], obj.message);


				makeActiveView("editServices");
				Ext.getCmp("editServices").preProcessServices(obj.services);

			},
			failure: function(result, request) {

				var obj;

				obj = JSON.parse(result.responseText);
				if (!obj) {
					showError(l["Unexpected error"], result.responseText);
					return;
				}

				if (obj.message) {
					showError(l["Unexpected error"], obj.message);
					return;
				}

				showError(l["Connection	 error"], result);
			}


		});

	}

});
