/*
 * File: app/view/newService.js
 *
 * This file was generated by Sencha Architect version 3.0.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.newService', {
	extend: 'Ext.window.Window',

	requires: [
		'Ext.form.Panel',
		'Ext.form.field.Number',
		'Ext.form.field.ComboBox',
		'Ext.toolbar.Toolbar',
		'Ext.button.Button',
		'Ext.toolbar.Spacer'
	],

	draggable: false,
	height: 228,
	id: 'newService',
	width: 400,
	closable: false,
	title: 'Definir os parâmetros do serviço',
	modal: true,

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'form',
					id: 'serviceParamsPanel',
					bodyPadding: 20,
					header: false,
					title: 'Definir os parâmetros do serviço',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'textfield',
							id: 'newServiceServiceDescription',
							fieldLabel: 'Nome do serviço',
							labelSeparator: ' ',
							labelWidth: 140,
							enableKeyEvents: true,
							listeners: {
								blur: {
									fn: me.onNewServiceServiceDescriptionBlur,
									scope: me
								},
								beforerender: {
									fn: me.onNewServiceServiceDescriptionBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'numberfield',
							id: 'newServiceCheckInterval',
							fieldLabel: 'Intervalo de checagem',
							labelSeparator: ' ',
							labelWidth: 140,
							value: 5,
							minValue: 1,
							listeners: {
								beforerender: {
									fn: me.onNewServiceCheckIntervalBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'combobox',
							id: 'newServiceCheckPeriod',
							fieldLabel: 'Período de checagem',
							labelSeparator: ' ',
							labelWidth: 140,
							displayField: 'timeperiod_name',
							queryMode: 'local',
							store: 'timePeriodStore',
							valueField: 'timeperiod_id',
							listeners: {
								beforerender: {
									fn: me.onNewServiceCheckPeriodBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'combobox',
							id: 'newServiceServiceGroups',
							fieldLabel: 'Grupos de serviços',
							labelSeparator: ' ',
							labelWidth: 140,
							displayField: 'servicegroup_name',
							multiSelect: true,
							store: 'serviceGroupStore',
							valueField: 'servicegroup_id',
							listeners: {
								beforerender: {
									fn: me.onNewServiceServiceGroupsBeforeRender,
									scope: me
								}
							}
						}
					]
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar5',
					items: [
						{
							xtype: 'button',
							handler: function(button, event) {
								serviceStore = Wizard.getApplication().getServiceStoreStore();
								serviceStore.remove(serviceStore.getAt(serviceStore.getCount() - 1));
								Ext.getCmp("newService").close();
							},
							id: 'prevBtn9',
							text: 'Cancelar',
							listeners: {
								beforerender: {
									fn: me.onPrevBtn9BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										me = Ext.getCmp("newService");

										if (me.validateForm() === false) {
											return;
										}

										selectCommandWindow = Ext.create("Wizard.view.selectCommand");
										for(i=0; i<me.buckets.length; i++) {
											svc = me.buckets[i];
											svc.set("service_description",Ext.getCmp("newServiceServiceDescription").getValue());
											svc.set("normal_check_interval",Ext.getCmp("newServiceCheckInterval").getValue());
											svc.set("check_period",Ext.getCmp("newServiceCheckPeriod").getValue());
											svc.set("servicegroups",Ext.getCmp("newServiceServiceGroups").getValue());
											svc.set("selected", true);
											selectCommandWindow.addServiceBucket(svc);
										}

										selectCommandWindow.show();
									},
									id: 'nextBtn4',
									text: 'Adicionar Comando',
									listeners: {
										beforerender: {
											fn: me.onNextBtn4BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			],
			listeners: {
				show: {
					fn: me.onNewServiceShow,
					scope: me
				},
				beforerender: {
					fn: me.onNewServiceBeforeRender,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onNewServiceServiceDescriptionBlur: function(component, e, eOpts) {
		component.setValue(
		changeCharCode(component.getValue())
		);
	},

	onNewServiceServiceDescriptionBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Service Name"];
	},

	onNewServiceCheckIntervalBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Check Interval"];
	},

	onNewServiceCheckPeriodBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Period"];
	},

	onNewServiceServiceGroupsBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Service Groups"];
	},

	onPrevBtn9BeforeRender: function(component, eOpts) {
		component.text = l["Back"];
	},

	onNextBtn4BeforeRender: function(component, eOpts) {
		component.text = l["Next"];
	},

	onNewServiceShow: function(component, eOpts) {
		// component in this case is newService window
		me = component;

		if (me.buckets === undefined) {
			return;
		}

		// even if we are editing a lot of services
		// we only render the first one
		svc = me.buckets[0];
		Ext.getCmp("newServiceServiceDescription").setValue(svc.get("service_description"));
		Ext.getCmp("newServiceCheckInterval").setValue(svc.get("normal_check_interval"));
		Ext.getCmp("newServiceCheckPeriod").setValue(svc.get("check_period").toString());
		Ext.getCmp("newServiceServiceGroups").setValue(svc.get("servicegroups"));
	},

	onNewServiceBeforeRender: function(component, eOpts) {
		component.title = l["Create service"];
	},

	addServiceBucket: function(bucket) {
		if (this.buckets === undefined) {
			this.buckets = [];
		}

		this.buckets.push(bucket);
	},

	validateForm: function() {
		if (Ext.getCmp('newServiceServiceDescription').getValue() == "") {
			showError("Error","Invalid service description");
			return false;
		}

		if (Ext.getCmp('newServiceCheckPeriod').getValue() == "") {
			showError("Error","Invalid check period");
			return false;
		}

		return true;
	}

});