/*
 * File: app/view/selectCommand.js
 *
 * This file was generated by Sencha Architect version 3.0.2.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.selectCommand', {
	extend: 'Ext.window.Window',

	requires: [
		'Ext.form.Panel',
		'Ext.form.field.ComboBox',
		'Ext.form.Label',
		'Ext.toolbar.Toolbar',
		'Ext.button.Button',
		'Ext.toolbar.Spacer'
	],

	draggable: false,
	height: 370,
	id: 'selectCommandWindow',
	width: 600,
	layout: 'accordion',
	title: 'Adicionar Comando ao Serviço',
	modal: true,

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'form',
					cls: 'wizard-accordion',
					id: 'commandSelectPanel',
					bodyPadding: '20 20 0',
					collapsible: true,
					glyph: 49,
					title: 'Selecione um comando',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'combobox',
							flex: 1,
							height: 22,
							id: 'commandSelector',
							maxHeight: 22,
							minHeight: 22,
							fieldLabel: '',
							hideLabel: true,
							labelWidth: 160,
							emptyText: 'Selecione um comando disponível',
							displayField: 'command_name',
							queryMode: 'local',
							store: 'commandStore',
							valueField: 'command_id',
							listeners: {
								change: {
									fn: me.onCommandSelectorChange,
									scope: me
								},
								beforerender: {
									fn: me.onCommandSelectorBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'container',
							cls: 'grey-bg',
							id: 'commandData',
							padding: '10 20',
							items: [
								{
									xtype: 'label',
									id: 'commandLine',
									margin: '5 0 0',
									text: ''
								}
							]
						}
					],
					dockedItems: [
						{
							xtype: 'toolbar',
							flex: 1,
							dock: 'bottom',
							layout: {
								type: 'hbox',
								padding: '0 10'
							},
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										Ext.create(Wizard.view.createCommand).show();
									},
									id: 'addNewCommandBtn',
									glyph: 43,
									text: 'Adicionar um novo comando à lista',
									listeners: {
										beforerender: {
											fn: me.onAddNewCommandBtnBeforeRender,
											scope: me
										}
									}
								}
							]
						}
					],
					listeners: {
						beforerender: {
							fn: me.onCommandSelectPanelBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'form',
					cls: 'wizard-accordion',
					id: 'commandArgsPanel',
					autoScroll: true,
					glyph: 50,
					title: 'Defina os argumentos do comando selecionado',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					dockedItems: [
						{
							xtype: 'container',
							flex: 1,
							dock: 'top',
							minHeight: 36,
							padding: '10 20',
							layout: {
								type: 'vbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									flex: 1,
									cls: 'grey-bg',
									padding: '10 20',
									items: [
										{
											xtype: 'label',
											id: 'commandWithArgs'
										}
									]
								}
							]
						}
					],
					items: [
						{
							xtype: 'container',
							flex: 1,
							id: 'parametersContainer',
							margin: '0 20 0',
							padding: '2 20 2 0',
							autoScroll: true,
							layout: {
								type: 'vbox',
								align: 'stretch'
							}
						}
					],
					listeners: {
						beforeexpand: {
							fn: me.onCommandArgsPanelBeforeExpand,
							scope: me
						},
						beforerender: {
							fn: me.onCommandArgsPanelBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'form',
					cls: 'wizard-accordion',
					id: 'testCommand',
					autoScroll: true,
					bodyPadding: 20,
					glyph: 51,
					title: 'Teste o comando',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'container',
							layout: {
								type: 'hbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'combobox',
									flex: 2,
									height: 36,
									id: 'hostTest',
									maxHeight: 20,
									padding: '0 10 0 0',
									fieldLabel: 'Selecione um host',
									labelSeparator: ' ',
									labelWidth: 120,
									allowBlank: false,
									displayField: 'host_name',
									queryMode: 'local',
									store: 'hostStore',
									valueField: 'host_name',
									listeners: {
										beforerender: {
											fn: me.onHostTestBeforeRender,
											scope: me
										}
									}
								},
								{
									xtype: 'button',
									handler: function(button, event) {
										me = Ext.getCmp("selectCommandWindow");

										if (me.isSelectedCommandValid() === false) {
											return;
										}

										if (me.isSelectedHostValid() === false) {
											return;
										}

										me.doTestCommand();
									},
									height: 24,
									id: 'testCommand4',
									maxHeight: 24,
									minHeight: 24,
									text: 'Testar comando',
									listeners: {
										beforerender: {
											fn: me.onTestCommand4BeforeRender,
											scope: me
										}
									}
								}
							]
						},
						{
							xtype: 'container',
							cls: 'green-bg',
							margin: '5 0 0',
							padding: '10 20',
							items: [
								{
									xtype: 'label',
									text: 'Standard Output: '
								},
								{
									xtype: 'label',
									id: 'stdOut',
									text: ''
								}
							]
						},
						{
							xtype: 'container',
							cls: 'red-bg',
							margin: '5 0 0',
							padding: '10 20',
							items: [
								{
									xtype: 'label',
									text: 'Standard Error: '
								},
								{
									xtype: 'label',
									id: 'stdErr',
									text: ''
								}
							]
						}
					],
					listeners: {
						beforerender: {
							fn: me.onTestCommandBeforeRender,
							scope: me
						}
					}
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar6',
					items: [
						{
							xtype: 'button',
							handler: function(button, event) {
								Ext.getCmp('selectCommandWindow').close();
							},
							id: 'prevBtn10',
							text: 'Voltar',
							listeners: {
								beforerender: {
									fn: me.onPrevBtn10BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										me = Ext.getCmp("selectCommandWindow");

										if (me.isSelectedCommandValid() === false) {
											showError(l["Error"],l["Please select a command"])
											return;
										}

										me.updateBuckets();

										grid = Ext.getCmp('serviceGrid');
										if (grid !== undefined) {
											grid.rerenderBuckets();
										}

										/* close windows */
										try {

											w = Ext.getCmp('selectCommandWindow');
											if (w !== undefined) {
												w.close();
											}

											w = Ext.getCmp('newService');
											if (w !== undefined) {
												w.close();
											}

											w = Ext.getCmp('newService1');
											if (w !== undefined) {
												w.close();
											}
										} catch(e) {
											/*no time*/
										}

										showInfo(l["Information"],l["Service successfully updated"]);

										if (me.callback !== undefined) {
											me.callback();
										}
									},
									id: 'nextBtn5',
									text: 'Aplicar comando ao serviço',
									listeners: {
										beforerender: {
											fn: me.onNextBtn5BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			],
			listeners: {
				show: {
					fn: me.onSelectCommandWindowShow,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onCommandSelectorChange: function(field, newValue, oldValue, eOpts) {
		me = Ext.getCmp("selectCommandWindow");

		if (me.isSelectedCommandValid() === false) {
			return;
		}

		me.updateCommandLines();
	},

	onCommandSelectorBeforeRender: function(component, eOpts) {
		component.emptyText = l["Select an available command"];
	},

	onAddNewCommandBtnBeforeRender: function(component, eOpts) {
		component.text = l["Add a new command to the list"];
	},

	onCommandSelectPanelBeforeRender: function(component, eOpts) {
		component.title = l["Select a command"];
	},

	onCommandArgsPanelBeforeExpand: function(p, animate, eOpts) {
		if (cid === undefined || cid === null) {
			return;
		}

		Ext.getCmp("selectCommandWindow").createParameterFields();
		Ext.getCmp("selectCommandWindow").parameterChanged();
	},

	onCommandArgsPanelBeforeRender: function(component, eOpts) {
		component.title = l["Set the arguments of the selected command"];
	},

	onHostTestBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Select a host"];
	},

	onTestCommand4BeforeRender: function(component, eOpts) {
		component.text = l["Test command"];
	},

	onTestCommandBeforeRender: function(component, eOpts) {
		component.title = l["Test command"];
	},

	onPrevBtn10BeforeRender: function(component, eOpts) {
		component.text = l["Back"];
	},

	onNextBtn5BeforeRender: function(component, eOpts) {
		component.text = l["Apply command to the service"];
	},

	onSelectCommandWindowShow: function(component, eOpts) {
		// component in this case is selectCommand window
		me = component;

		if (me.buckets === undefined) {
			showError("Error","no buckets");
			return;
		}

		// even if we are editing a lot of services
		// we only render the first one
		svc = me.buckets[0];
		Ext.getCmp("commandSelector").setValue(svc.get("check_command")); /* cascade events */


		hosts = Wizard.getApplication().getHostStoreStore();
		if (hosts.getCount() == 0) {
			Ext.getCmp("hostTest").bindStore(Wizard.getApplication().getAlreadyMonitoredHostStoreStore());
		}

	},

	addServiceBucket: function(bucket) {
		me = Ext.getCmp("selectCommandWindow");

		if (me.buckets === undefined) {
			me.buckets = [];
		}

		me.buckets.push(bucket);
	},

	createParameterFields: function() {
		// me is selectCommand window
		me = Ext.getCmp("selectCommandWindow");

		command = me.getSelectedCommand();
		paramContainer = Ext.getCmp("parametersContainer");
		count = command.get("command_line").match(/\$ARG\d+\$/g);


		paramContainer.removeAll(true);
		me.commandParameters = [];
		if (count === null) {
			return;
		}

		editServicesWindow = Ext.getCmp("editServices");

		//
		// render only the first bucket,
		// we have room for only one
		// service anyway
		//
		svc = me.buckets[0];
		params = svc.get("check_parameters");
		for (i=0; i<count.length; i++) {

			var field = Ext.create("Wizard.view.parameterField");
			field.setFieldLabel(count[i]);
			if (params[i] !== undefined) {
				field.setValue(params[i]);
			}

			if (editServicesWindow) {
				/* i warn you, be careful. horrible stuff ahead! */

				tooltip  = "<table width='300px'>";
				tooltip += "    <tr>";
				tooltip += "        <td>Host</td>";
				tooltip += "        <td>"+count[i]+"</td>";
				tooltip += "    </tr>"
				for(j=0; j<editServicesWindow.allServicesBeingEdited.length; j++) {

					o = editServicesWindow.allServicesBeingEdited[j];
					if (o.service_description != svc.get("service_description") ||
					o.check_command != svc.get("check_command")) {
						continue;
					}

					p = o.check_parameters;
					tooltip += "<tr>";
					tooltip += "    <td>"+o.host_name+"</td>";

					x = "";
					if (p[i] !== undefined) {
						x = p[i];
					}

					tooltip += "    <td>"+x+"</td>";
					tooltip += "</tr>";

				}
				tooltip += "</table>";
				field.setToolTipText(tooltip);
			}


			paramContainer.add(field);
			me.commandParameters.push(field);
		}
	},

	isSelectedCommandValid: function() {
		commandStore = Wizard.getApplication().getCommandStoreStore();
		cid = commandStore.getById(Ext.getCmp('commandSelector').getValue());
		if (cid === null) {
			return false;
		}

		return true;
	},

	getSelectedCommand: function() {
		commandStore = Wizard.getApplication().getCommandStoreStore();
		cid = commandStore.getById(Ext.getCmp('commandSelector').getValue());
		return cid;
	},

	updateCommandLines: function() {
		Ext.getCmp("commandLine").setText(cid.get("command_line"));
		Ext.getCmp("commandWithArgs").setText(cid.get("command_line"));
	},

	parameterChanged: function() {
		// me is select command window
		me = Ext.getCmp("selectCommandWindow");

		if (me.commandParameters === undefined || me.commandParameters.length == 0) {
			return;
		}

		commandLine = Ext.getCmp("commandLine").text;
		for(i=0; i<me.commandParameters.length; i++) {
			field = me.commandParameters[i];
			if (field.getValue() == "") {
				continue;
			}
			commandLine = commandLine.replace(field.getFieldLabel(), field.getValue());
		}
		Ext.getCmp("commandWithArgs").setText(commandLine);
	},

	isSelectedHostValid: function() {
		hostStore = Wizard.getApplication().getHostStoreStore();
		hostPos = hostStore.find("host_name",Ext.getCmp('hostTest').getValue());
		if (hostPos === null || hostPos < 0) {
			showError(l["Invalid host"],l["Please select a host to be tested"]);
			return false;
		}
		return true;
	},

	getCommandParameters: function() {
		me = Ext.getCmp("selectCommandWindow");

		commandParameters = {};

		hostStore = Wizard.getApplication().getHostStoreStore();
		hostPos = hostStore.find("host_name",Ext.getCmp('hostTest').getValue());

		host = hostStore.getAt(hostPos);
		for (i=0; i<me.commandParameters.length; i++) {
			field = me.commandParameters[i];
			commandParameters[field.getFieldLabel()] = field.getValue();
		}

		return commandParameters;
	},

	doTestCommand: function() {
		me = Ext.getCmp("selectCommandWindow");

		commandId = me.getSelectedCommand().get("command_id");
		params = me.getCommandParameters();
		host = me.getSelectedHost();

		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/discovery/action/runcommand/',
			method: 'POST',
			params: {
				command_id: commandId,
				host: JSON.stringify(host.raw),
				parameters: JSON.stringify(params)
			},
			success: function(result, request) {
				obj = JSON.parse(result.responseText);
				if (!obj) {
					showError(l["Unexpected error"],l["JSON not found"]);
					return;
				}

				if (!obj.success) {
					showError(l["Unexpected error"],obj.message);
					return;
				}

				Ext.getCmp('stdOut').setText(obj.std_out);
				Ext.getCmp('stdErr').setText(obj.std_err);

			},
			failure: function(result, request) {
				showError(l["Error"], result.responseText);
			}
		});
	},

	getSelectedHost: function() {
		hostStore = Wizard.getApplication().getHostStoreStore();
		hostPos = hostStore.find("host_name",Ext.getCmp('hostTest').getValue());
		return hostStore.getAt(hostPos);
	},

	getCommandParametersAsArray: function() {
		me = Ext.getCmp("selectCommandWindow");

		commandParameters = [];

		hostStore = Wizard.getApplication().getHostStoreStore();
		hostPos = hostStore.find("host_name",Ext.getCmp('hostTest').getValue());

		host = hostStore.getAt(hostPos);
		for (i=0; i<me.commandParameters.length; i++) {
			field = me.commandParameters[i];
			commandParameters.push(field.getValue());
		}

		return commandParameters;
	},

	updateBuckets: function() {
		me = Ext.getCmp("selectCommandWindow");

		params = me.getCommandParametersAsArray();
		for(i=0; i<me.buckets.length; i++) {
			svc = me.buckets[i];
			svc.set("check_command", Ext.getCmp('commandSelector').getValue());
			svc.set("check_parameters", params);
		}

		// add buckets to global hosts
		hostStore = Wizard.getApplication().getHostStoreStore();
		for(i=0; i<hostStore.getCount(); i++) {
			host = hostStore.getAt(i);
			for(j=0; j<me.buckets.length; j++) {
				host.addService(Ext.clone(me.buckets[j].data));
			}
		}
	},

	setCallBack: function(cb) {
		me = Ext.getCmp("selectCommandWindow");
		me.callback = cb;
	}

});