/*
 * File: app/view/selectHostOrigin.js
 *
 * This file was generated by Sencha Architect version 3.0.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.selectHostOrigin', {
	extend: 'Ext.window.Window',

	requires: [
		'Ext.form.Panel',
		'Ext.form.field.ComboBox',
		'Ext.form.Label',
		'Ext.toolbar.Toolbar',
		'Ext.toolbar.Spacer',
		'Ext.button.Button'
	],

	draggable: false,
	height: 280,
	id: 'selectHostOrigin',
	width: 400,
	bodyPadding: '20 30',
	header: false,
	title: 'Adicionar Host',
	modal: true,

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			layout: {
				type: 'vbox',
				align: 'stretch'
			},
			items: [
				{
					xtype: 'panel',
					flex: 1,
					id: 'selectionPanel',
					layout: 'accordion',
					collapsible: true,
					header: false,
					title: 'Defina a origem do host a ser adicionado',
					items: [
						{
							xtype: 'panel',
							cls: 'x-btn-default-small',
							id: 'discoveredPanel',
							bodyPadding: 10,
							collapsible: false,
							hideCollapseTool: true,
							title: 'Selecionar um host já descoberto',
							items: [
								{
									xtype: 'form',
									id: 'discoveredForm',
									header: false,
									title: 'My Form',
									items: [
										{
											xtype: 'combobox',
											anchor: '100%',
											id: 'discoveredHostHostName',
											margin: '0 0 20 0',
											fieldLabel: 'Label',
											hideLabel: true,
											emptyText: 'Selecione um host',
											displayField: 'host_name',
											multiSelect: true,
											queryMode: 'local',
											store: 'hostDiscoveryStore',
											valueField: 'host_name',
											listeners: {
												beforerender: {
													fn: me.onDiscoveredHostHostNameBeforeRender,
													scope: me
												}
											}
										}
									]
								},
								{
									xtype: 'label',
									cls: 'bold',
									text: 'Serão listados somente os hosts encontrados pelo módulo de desoberta do OpMon',
									listeners: {
										beforerender: {
											fn: me.onLabelBeforeRender,
											scope: me
										}
									}
								}
							],
							listeners: {
								beforerender: {
									fn: me.onDiscoveredPanelBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'panel',
							cls: 'x-btn-default-small',
							id: 'manualPanel',
							collapsible: false,
							hideCollapseTool: true,
							title: 'Adicionar host manualmente',
							items: [
								{
									xtype: 'form',
									id: 'manualForm',
									bodyPadding: 10,
									header: false,
									title: 'My Form',
									items: [
										{
											xtype: 'textfield',
											anchor: '100%',
											id: 'manualHostHostName',
											fieldLabel: 'Nome',
											labelSeparator: ' ',
											labelWidth: 80,
											enableKeyEvents: true,
											listeners: {
												blur: {
													fn: me.onManualHostHostNameBlur,
													scope: me
												},
												beforerender: {
													fn: me.onManualHostHostNameBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'textfield',
											anchor: '100%',
											id: 'manualHostAddress',
											fieldLabel: 'IP',
											labelSeparator: ' ',
											labelWidth: 80,
											listeners: {
												beforerender: {
													fn: me.onManualHostAddressBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'textfield',
											anchor: '100%',
											id: 'manualHostAlias',
											fieldLabel: 'Descrição',
											labelSeparator: ' ',
											labelWidth: 80,
											listeners: {
												beforerender: {
													fn: me.onManualHostAliasBeforeRender,
													scope: me
												}
											}
										}
									]
								}
							],
							listeners: {
								beforerender: {
									fn: me.onManualPanelBeforeRender,
									scope: me
								}
							}
						}
					]
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar11',
					items: [
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										var expandedPanel;

										expandedPanel = Ext.getCmp("selectionPanel").child("[collapsed=false]").id;

										if (expandedPanel == "discoveredPanel") {

											selectedHostName = Ext.getCmp('discoveredHostHostName').getValue();
											if (selectedHostName === null) {
												showError(l["Error"],l["Please select a host already discovered"]);
												return;
											}

											Ext.Ajax.request({
												url: '/opmon/seagull/www/index.php/discovery/action/hostbuckets/',
												method: "POST",
												params: {
													hosts_being_edited: JSON.stringify(selectedHostName)
												},
												success: function(result, request) {

													var app;
													app = Wizard.getApplication().getEditHostsControllerController();
													try {
														app.addHostBuckets(JSON.parse(result.responseText));
													}catch(e) {
														showError(l["Unexpected error"], e.message);
														return;
													}

													Ext.getCmp('selectHostOrigin').close();

												},
												failure: function(result, request) {
													showError(l["Unexpected error"],result.responseText);
												}

											});
											return;
										}

										if (expandedPanel == "manualPanel") {

											hostName = Ext.getCmp("manualHostHostName").getValue();
											if (hostName == "") {
												showError(l["Error"],l["Invalid hostname"]);
												return;
											}
											hostAddress = Ext.getCmp("manualHostAddress").getValue();
											if (hostAddress == "") {
												showError(l["Error"],l["Invalid IP"]);
												return;
											}

											hostAlias = Ext.getCmp("manualHostAlias").getValue();

											Ext.Ajax.request({
												url: '/opmon/seagull/www/index.php/discovery/action/get_host_bucket/',
												method: "GET",
												success: function(result, request) {

													var app;
													app = Wizard.getApplication().getEditHostsControllerController();

													try {
														host = JSON.parse(result.responseText);
														host.host_name = hostName;
														host.address = hostAddress;
														host.alias = hostAlias;
														app.addHostBuckets(host);

													}catch(e) {
														showError(l["Unexpected error"], e.message);
														return;
													}
													Ext.getCmp('selectHostOrigin').close();
												},
												failure: function(result, request) {
													showError(l["Unexpected error"], result.responseText);
												}
											});

										}
									},
									id: 'nextBtn11',
									text: 'Avançar',
									listeners: {
										beforerender: {
											fn: me.onNextBtn11BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onDiscoveredHostHostNameBeforeRender: function(component, eOpts) {
		component.emptyText = l["Select a host"];
	},

	onLabelBeforeRender: function(component, eOpts) {
		component.text = l["Will be listed only hosts found by the discovery module"];
	},

	onDiscoveredPanelBeforeRender: function(component, eOpts) {
		component.title = l["Select a host already discovered"];
	},

	onManualHostHostNameBlur: function(component, e, eOpts) {
		f = Ext.getCmp("manualHostHostName");

		f.setValue(
			changeCharCode(f.getValue())
		);
	},

	onManualHostHostNameBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Host Name"];
	},

	onManualHostAddressBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["IP"];
	},

	onManualHostAliasBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Description"];
	},

	onManualPanelBeforeRender: function(component, eOpts) {
		component.title = l["Add host manually"];
	},

	onNextBtn11BeforeRender: function(component, eOpts) {
		component.text = l["Next"];
	}

});